#ifndef _DECL_barrier_H_
#define _DECL_barrier_H_
#include "charm++.h"
/* DECLS: message FP;
 */
class FP;
class CMessage_FP:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){dealloc(p);}
    void operator delete(void*p){dealloc(p);}
    void operator delete(void*p, int*, const int){dealloc(p);}
    void operator delete(void*p, int*){dealloc(p);}
#endif
    void operator delete(void*p, size_t){dealloc(p);}
    static void* alloc(int,size_t, int*, int);
    static void dealloc(void *p);
    CMessage_FP() {};
    static void *pack(FP *p);
    static FP* unpack(void* p);
    void *operator new(size_t, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, const int){dealloc(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, size);
    }
};

/* DECLS: group barrier: IrrGroup{
barrier(void);
void notify(void);
void callFP(void);
void reset(void);
void atBarrier(FP* impl_msg);
};
 */
 class barrier;
 class CkIndex_barrier;
 class CProxy_barrier;
 class CProxyElement_barrier;
/* --------------- index object ------------------ */
class CkIndex_barrier:public CProxyElement_IrrGroup{
  public:
    typedef barrier local_t;
    typedef CkIndex_barrier index_t;
    typedef CProxy_barrier proxy_t;
    typedef CProxyElement_barrier element_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: barrier(void);
 */
    static int __idx_barrier_void;
    static int ckNew(void) { return __idx_barrier_void; }
    static void _call_barrier_void(void* impl_msg,barrier* impl_obj);

/* DECLS: void notify(void);
 */
    static int __idx_notify_void;
    static int notify(void) { return __idx_notify_void; }
    static void _call_notify_void(void* impl_msg,barrier* impl_obj);

/* DECLS: void callFP(void);
 */
    static int __idx_callFP_void;
    static int callFP(void) { return __idx_callFP_void; }
    static void _call_callFP_void(void* impl_msg,barrier* impl_obj);

/* DECLS: void reset(void);
 */
    static int __idx_reset_void;
    static int reset(void) { return __idx_reset_void; }
    static void _call_reset_void(void* impl_msg,barrier* impl_obj);

/* DECLS: void atBarrier(FP* impl_msg);
 */
    static int __idx_atBarrier_FP;
    static int atBarrier(FP* impl_msg) { return __idx_atBarrier_FP; }
    static void _call_atBarrier_FP(void* impl_msg,barrier* impl_obj);
};
/* --------------- element proxy ------------------ */
class CProxyElement_barrier: public CProxyElement_IrrGroup{
  public:
    typedef barrier local_t;
    typedef CkIndex_barrier index_t;
    typedef CProxy_barrier proxy_t;
    typedef CProxyElement_barrier element_t;

    CProxyElement_barrier(void) {}
    CProxyElement_barrier(const IrrGroup *g) : CProxyElement_IrrGroup(g){  }
    CProxyElement_barrier(CkGroupID _gid,int _onPE,CK_DELCTOR_PARAM) : CProxyElement_IrrGroup(_gid,_onPE,CK_DELCTOR_ARGS){  }
    CProxyElement_barrier(CkGroupID _gid,int _onPE) : CProxyElement_IrrGroup(_gid,_onPE){  }
   CK_DISAMBIG_GROUP_ELEMENT(CProxyElement_IrrGroup)
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxyElement_IrrGroup::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxyElement_IrrGroup::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_IrrGroup::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxyElement_IrrGroup::ckSetGroupID(g);
    }
    barrier* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static barrier* ckLocalBranch(CkGroupID gID) {
      return (barrier*)CkLocalBranch(gID);
    }
/* DECLS: barrier(void);
 */

/* DECLS: void notify(void);
 */
    void notify(void);

/* DECLS: void callFP(void);
 */
    void callFP(void);

/* DECLS: void reset(void);
 */
    void reset(void);

/* DECLS: void atBarrier(FP* impl_msg);
 */
    void atBarrier(FP* impl_msg);
};
PUPmarshall(CProxyElement_barrier);
/* ---------------- collective proxy -------------- */
class CProxy_barrier: public CProxy_IrrGroup{
  public:
    typedef barrier local_t;
    typedef CkIndex_barrier index_t;
    typedef CProxy_barrier proxy_t;
    typedef CProxyElement_barrier element_t;

    CProxy_barrier(void) {}
    CProxy_barrier(const IrrGroup *g) : CProxy_IrrGroup(g){  }
    CProxy_barrier(CkGroupID _gid,CK_DELCTOR_PARAM) : CProxy_IrrGroup(_gid,CK_DELCTOR_ARGS){  }
    CProxy_barrier(CkGroupID _gid) : CProxy_IrrGroup(_gid){  }
    CProxyElement_barrier operator[](int onPE) const
      {return CProxyElement_barrier(ckGetGroupID(),onPE,CK_DELCTOR_CALL);}
   CK_DISAMBIG_GROUP(CProxy_IrrGroup)
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_IrrGroup::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_IrrGroup::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_IrrGroup::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxy_IrrGroup::ckSetGroupID(g);
    }
    barrier* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static barrier* ckLocalBranch(CkGroupID gID) {
      return (barrier*)CkLocalBranch(gID);
    }
/* DECLS: barrier(void);
 */
    static CkGroupID ckNew(void);

/* DECLS: void notify(void);
 */
    void notify(void);
    void notify(int npes, int *pes);

/* DECLS: void callFP(void);
 */
    void callFP(void);
    void callFP(int npes, int *pes);

/* DECLS: void reset(void);
 */
    void reset(void);
    void reset(int npes, int *pes);

/* DECLS: void atBarrier(FP* impl_msg);
 */
    void atBarrier(FP* impl_msg);
    void atBarrier(FP* impl_msg, int npes, int *pes);
};
PUPmarshall(CProxy_barrier);
typedef CBaseT<Group,CProxy_barrier>  CBase_barrier;

extern void _registerbarrier(void);
#endif
